/*$Id: d_coil.h,v 13.36 1999/05/07 08:37:41 al Exp $ -*- C++ -*-
 * Inductance (L) component
 */
#ifndef D_COIL_H
#define D_COIL_H
#include "e_storag.h"
/*--------------------------------------------------------------------------*/
class DEV_INDUCTANCE : public STORAGE {
private:
  explicit	DEV_INDUCTANCE(const DEV_INDUCTANCE& p):STORAGE(p){}
public:
  explicit	DEV_INDUCTANCE()	{}
private: // overloaded virtual
  CARD*		clone()const		{return new DEV_INDUCTANCE(*this);}
  bool		dotr();
  CARD&		trload();
  CARD&		trunload();
  CARD&		doac();
  double	tr_review();
  const char*	devtype()const		{return "inductor";}
private:
  void		integrate();
};
/*--------------------------------------------------------------------------*/
class DEV_MUTUAL_L : public COMPONENT {
private:
  explicit	DEV_MUTUAL_L(const DEV_MUTUAL_L& p);
public:
  explicit	DEV_MUTUAL_L();
private: // overloaded virtual
  CARD*		clone()const	{untested(); return new DEV_MUTUAL_L(*this);}
  CARD&		parse(CS&);
  const CARD&	print(OMSTREAM where, int detail)const;
  CARD&		expand();
  bool		dotr()			{return true;}
  CARD&		trload()		{return *this;}
  CARD&		trunload()		{untested(); return *this;}
  CARD&		doac()			{return *this;}
  double	tr_involts()const
			{untested(); return dn_diff(n[IN1].v0(), n[IN2].v0());}
  COMPLEX	ac_involts()const{untested();return n[IN1].vac()-n[IN2].vac();}
  const char*	devtype()const		{return "mutual_inductor";}
  bool		is2port()const		{untested(); return true;}
private:
  char		outputlabel[LABELEN+1];
  CARD*		output;
  char		inputlabel[LABELEN+1];
  CARD*		input;
};
/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/
#endif
