/*$Id: d_cs.cc,v 13.32 1999/04/25 07:12:45 al Exp $ -*- C++ -*-
 * functions for fixed current source
 * x = 0, y.f0 = nothing, ev = y.f1 = amps.
 */
#include "d_cs.h"
/*--------------------------------------------------------------------------*/
//	void	DEV_CS::expand();
// 	bool	DEV_CS::dotr();
// 	void	DEV_CS::doac();
/*--------------------------------------------------------------------------*/
CARD& DEV_CS::expand()
{
  assert(loss == 0.);
  m0.x = 0.;
  y0.x = 0.;
  m0.c0 = y0.f1 = value();
  m0.f1 = y0.f0 = 0.;
  acg = ev = 0.;
  setconstant(!has_tr_eval());
  return *this;
}
/*--------------------------------------------------------------------------*/
bool DEV_CS::dotr()
{
  assert(!isbypassed());
  assert(m0.x == 0.);
  assert(y0.x == 0.);
  if (has_tr_eval()){
    tr_eval();
    store_values();
    SIM::loadq.push(this);
    m0.f1 = 0.;
    m0.c0 = y0.f1;
  }else{
    untested();
    assert(m0.c0 == value());
    assert(y1 == y0);
    assert(converged());
  }
  return converged();
}
/*--------------------------------------------------------------------------*/
CARD& DEV_CS::doac()
{
  if (has_ac_eval()){
    acbias = 0.;
    ac_eval();
    acg = ev;
    acload_source();
  }else{
    assert(acg == 0.);
  }
  return *this;
}
/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/
