/*$Id: d_trln.h,v 13.36 1999/05/07 08:37:41 al Exp $ -*- C++ -*-
 * structures, etc. for transmission lines
 */
#ifndef D_TRNLIN_H
#define D_TRNLIN_H
#include "l_denoise.h"
#include "e_elemnt.h"
/*--------------------------------------------------------------------------*/
enum {NUM_INIT_COND = 4};
/*--------------------------------------------------------------------------*/
class TRANSLINE_COMMON : public COMPONENT_COMMON {
public:
  explicit TRANSLINE_COMMON(int c=0);
  explicit TRANSLINE_COMMON(const TRANSLINE_COMMON& p);
  const char* name()const	{untested(); return "transline";}
  double   z0;			/* characteristic impedance */
  double   td;			/* delay time (not used, yet) */
  double   f;			/* specification frequency */
  double   nl;			/* length (wavelengths) at f */
  double   ic[NUM_INIT_COND];	/* initial conditions: v1, i1, v2, i2	*/
  double   reson;		/* quarter wave frequency */
  int	   icset;		/* flag: initial condition set */
};
/*--------------------------------------------------------------------------*/
class DEV_TRANSLINE : public ELEMENT {
private:
  explicit	DEV_TRANSLINE(const DEV_TRANSLINE& p):ELEMENT(p){untested();}
public:
  explicit	DEV_TRANSLINE();
private: // overloaded virtual
  CARD*		clone()const	{untested();return new DEV_TRANSLINE(*this);}
  CARD&		parse(CS&);
  const CARD&	print(OMSTREAM,int)const;
  CARD&		expand()		{untested(); return *this;}
  bool		dotr();
  CARD&		trload()		{untested(); return *this;}
  CARD&		trunload()		{untested(); return *this;}
  CARD&		doac();
  double	tr_involts()const
			{untested(); return dn_diff(n[IN1].v0(), n[IN2].v0());}
  COMPLEX	ac_involts()const 
			{untested(); return n[IN1].vac() - n[IN2].vac();}
  int		numnodes()const		{return 4;}
  bool		is2port()const		{untested(); return true;}
  const char*	devtype()const		{return "tline";}
private:
  void		setinitcond(CS&);
};
/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/
#endif
