/*$Id: e_base.cc,v 13.28 1999/04/11 08:25:27 al Exp $ -*- C++ -*-
 * Base class for "cards" in the circuit description file
 */
#include "s__.h"
#include "u_prblst.h"
#include "u_xprobe.h"
#include "constant.h"
#include "e_base.h"
/*--------------------------------------------------------------------------*/
//		 CKT_BASE()::~CKT_BASE();
//	char*	 CKT_BASE::probe_txt(const char*)const;
//	double	 CKT_BASE::probe_num(const char*)const;
	double	 CKT_BASE::probe_tr_num(const char*)const
				{unreachable();return NOT_VALID;}
//	double	 CKT_BASE::probe_ac_num(const char*)const;
	XPROBE CKT_BASE::probe_ac_ext(const char*)const
				{unreachable();return XPROBE();}
/*--------------------------------------------------------------------------*/
BSMATRIX<double>  CKT_BASE::aa;
BSMATRIX<double>  CKT_BASE::lu;
BSMATRIX<COMPLEX> CKT_BASE::acx;
int		  CKT_BASE::_devcount = 0;
/*--------------------------------------------------------------------------*/
CKT_BASE::~CKT_BASE()
{
  trace1("~CKT_BASE", _probes);
  PROBE_LISTS::purge(this);
  trace1("", _probes);
  assert(_probes==0);
  --_devcount;
}
/*--------------------------------------------------------------------------*/
const char* CKT_BASE::probe_txt(const char *what)const
{
  return ftos(probe_num(what),11,5,IO::formaat);
}
/*--------------------------------------------------------------------------*/
double CKT_BASE::probe_num(const char *what)const
{
  if (SIM::mode == sAC){
    return probe_ac_num(what);
  }else{
    return probe_tr_num(what);
  }
}
/*--------------------------------------------------------------------------*/
double CKT_BASE::probe_ac_num(const char *what)const
{
  int length = strlen(what);
  mod_t modifier = mtNONE;
  bool want_db = false;
  char parameter[LABELEN+1];
  strcpy(parameter, what);

  if (length > 2  &&  pmatch(&parameter[length-2], "DB")){
    want_db = true;
    length -= 2;
  }
  if (length > 1){ // selects modifier based on last letter of parameter
    switch (tolower(parameter[length-1])){
      case 'm': modifier = mtMAG;   length--;	break;
      case 'p': modifier = mtPHASE; length--;	break;
      case 'r': modifier = mtREAL;  length--;	break;
      case 'i': modifier = mtIMAG;  length--;	break;
      default:  modifier = mtNONE;		break;
    }
  }
  parameter[length] = '\0'; // chop
  
  XPROBE xp = probe_ac_ext(parameter); // chopped form
  if (!xp.OK()){
    xp = probe_ac_ext(what); // full form
  }
  return xp(modifier, want_db);
}
/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/
