/*$Id: e_elem2.cc,v 13.43 1999/06/01 15:25:51 al Exp $ -*- C++ -*-
 * Base class for elements of a circuit
 */
#include "ap.h"
#include "e_exp.h"
#include "e_bm.h" // includes e_elemnt.h
/*--------------------------------------------------------------------------*/
// void			ELEMENT::parsedevtype(CS& cmd);
// COMPONENT_COMMON*	ELEMENT::parsefunctype(CS&);
// ELEMENT&		ELEMENT::parsemorenodes(CS& cmd, int gotnodes)
// void			ELEMENT::parse(CS&);
// void			ELEMENT::print(int,int)const;
/*--------------------------------------------------------------------------*/
bool ELEMENT::skipdevtype(CS& cmd)
{
  return cmd.pmatch(devtype());
}
/*--------------------------------------------------------------------------*/
COMPONENT_COMMON* ELEMENT::parsefunctype(CS& cmd)
{
  if      (issource())          return 0;
  else if (cmd.pmatch("POLY" )) return new EVAL_BM_POLY;
  else if (cmd.pmatch("PWL"  )) return new EVAL_BM_PWL;
  //else if (cmd.pmatch("NPWL" )) return 0;
  //else if (cmd.pmatch("PPWL" )) return 0;
  //else if (cmd.pmatch("AND"  )) return 0;
  //else if (cmd.pmatch("NAND" )) return 0;
  //else if (cmd.pmatch("OR"   )) return 0;
  //else if (cmd.pmatch("NOR"  )) return 0;
  //else if (cmd.pmatch("DELAY")) return 0;
  else return 0;
}
/*--------------------------------------------------------------------------*/
ELEMENT& ELEMENT::parsemorenodes(CS& cmd, int gotnodes)
{
  int inports = is2port();
  if (cmd.skiplparen()){
    cmd >> inports;
    if (!cmd.skiprparen()){
      untested();
      cmd.warn(bWARNING);
    }
  }
  inports = is2port(); // unfinished, work around, only 1 input
  parsenodes(cmd, 2*inports+2, gotnodes);
  return *this;
}
/*--------------------------------------------------------------------------*/
CARD& ELEMENT::parse(CS& cmd)
{
  parselabel(cmd);
  int gotnodes = parsenodes(cmd,numnodes());
  skipdevtype(cmd); // (redundant)
  COMPONENT_COMMON* c = parsefunctype(cmd);
  parsemorenodes(cmd, gotnodes);
  if (!c){ // eval name mismatch, try old syntax .. label n1 n2 in ...
    parseexpr(cmd);
  }else{ // HS BM syntax .. label n1 n2 type eval in ...
    c->parse(cmd);
    attach_common(c);
  }
  return *this;
}
/*--------------------------------------------------------------------------*/
const CARD& ELEMENT::print(OMSTREAM where, int /*detail*/)const
{
  printlabel(where);
  printnodes(where,2);
  if (!common || dynamic_cast<const EXPRESSION_COMMON*>(common)){
    printnodes(where, numnodes(), 2);
    printexpr(where);
  }else{
    where << "  " << devtype() << ' ' << common->augname();
    printnodes(where, numnodes(), 2);
    common->print(where);
  }
  where << '\n';
  return *this;
}
/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/
