/*$Id: e_exp.cc,v 13.34 1999/05/03 08:18:39 al Exp $ -*- C++ -*-
 * Behavioral modeling parse and print functions.  This is a mess.
 * I plan to redo all of the behavioral modeling stuff.
 */
#include "ap.h"
#include "e_exp.h" // includes e_elemnt.h
/*--------------------------------------------------------------------------*/
//	void	ELEMENT::parseexpr(CS&);
// EXPRESSION_COMMON::EXPRESSION_COMMON(const int*k,int kc,...........
static	void	getkey(int*,int*,CS&);
//	void	ELEMENT::printexpr(int)const;
/*--------------------------------------------------------------------------*/
static const char e_om[] = "out of memory: %s\n";
/*--------------------------------------------------------------------------*/
void ELEMENT::parseexpr(CS& cmd)
{
  /* Basic stuff */
  setvalue(cmd.ctof());
  cmd.pmatch("METHOD") &&
      (  ::set(cmd, "Euler",	  &method_u, meEULER)
       ||::set(cmd, "EULEROnly",  &method_u, meEULERONLY)
       ||::set(cmd, "Trapezoidal",&method_u, meTRAP)
       ||::set(cmd, "TRAPOnly",	  &method_u, meTRAPONLY)
       ||::set(cmd, "Gear2",	  &method_u, meGEAR2)
       ||::set(cmd, "GEAR2Only",  &method_u, meGEAR2ONLY)
       ||::set(cmd, "TRAPGear",   &method_u, meTRAPGEAR)
    ||  cmd.warn(bWARNING));
       
  /* Attempt to parse the "expression" */
				/* Initially, they are unknown size, so	    */
  double numbers[EXPRSIZE];	/* there are two dynamic arrays		    */
  int keys[EXPRSIZE];		/* one for the keys			    */
  int numcount = 0;		/* other for arguments (doubles)	    */
  int keycount = 0;		/* keys are first.			    */
				/* use local fixed allocation.  Then copy   */
  for (;;){			/* in appropriate size to malloc space,	    */
    int key;			/* with links to parent branch struct.	    */
    int args;
    int paren = 0;
    getkey(&key, &args, cmd);
    if (!key){
      break;
    }
    if ((keycount + 1 >= EXPRSIZE) || (numcount + args > EXPRSIZE)){
      untested();
      error(bERROR, "expression too long\n");
    }
    keys[keycount++] = key;
    if (args == aVARIABLE){		/* variable # of args	    */
      double *argcount;			/* 1st arg is count	    */
      paren += cmd.skiplparen();
      argcount = &(numbers[numcount++]);
      *argcount = 1.;
      while (cmd.is_float()){
	numbers[numcount++] = cmd.ctof();
	(*argcount)++;
      }
      paren -= cmd.skiprparen();
    }else if (args == aASSIGN){
      cmd.skipequal();
      numbers[numcount++] = cmd.ctof();
    }else if (args > 0){
      paren += cmd.skiplparen();
      for (int arg1 = 1;  arg1 <= args;  arg1++)
	numbers[numcount++] = cmd.ctof();
      paren -= cmd.skiprparen();
    }else{
      /* no args, do nothing */
    }
    if (paren != 0){
      untested();
      cmd.warn(bWARNING);
    }
  }

  if (keycount > 0){
    EXPRESSION_COMMON* c =
      new EXPRESSION_COMMON(keys,keycount,numbers,numcount);
    attach_common(c);
  }else{
    detach_common();
  }
}
/*--------------------------------------------------------------------------*/
EXPRESSION_COMMON::EXPRESSION_COMMON(const int*k,int kc,const double*a,int ac)
  :COMPONENT_COMMON()
{
  keycount = kc+1;
  keys = new int[keycount];
  {for (int i=0; i<kc; ++i){
    keys[i] = k[i];
  }}
  keys[kc] = eEND;
  args = new double[ac];
  argcount = ac;
  {for (int i=0; i<ac; ++i){
    args[i] = a[i];
  }}
}
/*--------------------------------------------------------------------------*/
/* getkey: scan for a keyword. Return its key and desired arg count.
 * returns key == eNO if no match.
 */
static void getkey(int *key, int *args, CS& cmd)
{
      if (cmd.pmatch("AC"	  )) {*key = eAC; 	 *args = aAC;}
 else if (cmd.pmatch("DC"	  )) {*key = eDC; 	 *args = aDC;}
 else if (cmd.pmatch("DCTran"	  )) {*key = eDCTRAN;	 *args = aDCTRAN;}
 else if (cmd.pmatch("Frequency"  )) {*key = eFREQUENCY; *args = aFREQUENCY;}
 else if (cmd.pmatch("PEriod"	  )) {*key = ePERIOD;	 *args = aPERIOD;}
 else if (cmd.pmatch("Ramp"	  )) {*key = eRAMP;	 *args = aRAMP;}
 else if (cmd.pmatch("TIme"	  )) {*key = eTIME;	 *args = aTIME;}
 else if (cmd.pmatch("TRansient"  )) {*key = eTRAN;	 *args = aTRAN;}

 else if (cmd.pmatch("BAndwidth"  )) {*key = eBANDWIDTH; *args = aBANDWIDTH;}
 else if (cmd.pmatch("COMplex"	  )) {*key = eCOMPLEX;   *args = aCOMPLEX;}
 else if (cmd.pmatch("DElay"	  )) {*key = eDELAY;	 *args = aDELAY;}
 else if (cmd.pmatch("EXP"	  )) {*key = eEXP;	 *args = aEXP;}
 else if (cmd.pmatch("EXPTerm"	  )) {*key = eEXPTERM;   *args = aEXPTERM;}
 else if (cmd.pmatch("Generator"  )) {*key = eGENERATOR; *args = aGENERATOR;}
 else if (cmd.pmatch("NEtfunction")) {*key = eNETFUNC;   *args = aNETFUNC;}
 else if (cmd.is_float(		  )) {*key = eNUMERIC;   *args = aNUMERIC;}
 else if (cmd.pmatch("Offset"	  )) {*key = eOFFSET;	 *args = aOFFSET;}
 else if (cmd.pmatch("POLAr"	  )) {*key = ePOLAR;	 *args = aPOLAR;}
 else if (cmd.pmatch("POLYTerm"   )) {*key = ePOLYTERM;  *args = aPOLYTERM;}
 else if (cmd.pmatch("PUlse"	  )) {*key = ePULSE;	 *args = aPULSE;}
 else if (cmd.pmatch("PWl"	  )) {*key = ePWL;	 *args = aPWL;}
 else if (cmd.pmatch("SFfm"	  )) {*key = eSFFM;	 *args = aSFFM;}
 else if (cmd.pmatch("SIn"	  )) {*key = eSIN;	 *args = aSIN;}
 else if (cmd.pmatch("TABle"	  )) {*key = eTABLE;	 *args = aTABLE;}
 else if (cmd.pmatch("TANh"	  )) {*key = eTANH;	 *args = aTANH;}

 else if (cmd.pmatch("IC"	  )) {*key = eIC; 	 *args = aIC;}
 else if (cmd.pmatch("II"	  )) {*key = eII; 	 *args = aII;}
 else if (cmd.pmatch("IV"	  )) {*key = eIV; 	 *args = aIV;}
 else if (cmd.pmatch("TEmpco"	  )) {*key = eTEMPCO;	 *args = aTEMPCO;}
 else 	 {cmd.check(bWARNING);        *key = eNO;	 *args = 0;}
}
/*--------------------------------------------------------------------------*/
void ELEMENT::printexpr(OMSTREAM where)const
{
  where.setfloatwidth(7);
  if (!common  ||  value() != 0.){
    where << ' ' << value();
  }
  if (method_u != meUNKNOWN){
    untested();
    where << "  method=" << method_u;
  }

  if (common){
    const EXPRESSION_COMMON* c=dynamic_cast<const EXPRESSION_COMMON*>(common);
    if (!c){
      untested();
      error(bERROR, "%s: expression type mismatch\n", printlabel());
    }
    double* arg1 = c->args;
    for (int* key = c->keys;  *key != eEND;  ++key){
      const char *fname;
      int terms;
      switch (*key){
	 case eAC:	  fname = "ac";	   	terms = aAC;		break;
	 case eDC:	  fname = "dc";	   	terms = aDC;		break;
	 case eDCTRAN:    fname = "dctran";	terms = aDCTRAN;	break;
	 case eFREQUENCY: fname = "freq";	terms = aFREQUENCY;	break;
	 case ePERIOD:    fname = "period";	terms = aPERIOD;	break;
	 case eRAMP:	  fname = "ramp";	terms = aRAMP;		break;
	 case eTIME:	  fname = "time";	terms = aTIME;		break;
	 case eTRAN:	  fname = "tran";	terms = aTRAN;		break;

	 case eBANDWIDTH: fname = "bandwidth";  terms = aBANDWIDTH;	break;
	 case eCOMPLEX:   fname = "complex";	terms = aCOMPLEX;	break;
	 case eDELAY:     fname = "delay";	terms = aDELAY;		break;
	 case eEXP:	  fname = "exp";	terms = aEXP;		break;
	 case eEXPTERM:   fname = "expterm";	terms = aEXPTERM;	break;
	 case eGENERATOR: fname = "generator";  terms = aGENERATOR;	break;
	 case eNETFUNC:   fname = "netfunction";terms = aNETFUNC;	break;
	 case eNUMERIC:   fname = "";	   	terms = aNUMERIC;	break;
	 case eOFFSET:    fname = "offset";	terms = aOFFSET;	break;
	 case ePOLAR:     fname = "polar";	terms = aPOLAR;		break;
	 case ePOLYTERM:  fname = "polyterm";   terms = aPOLYTERM;	break;
	 case ePULSE:     fname = "pulse";	terms = aPULSE;		break;
	 case ePWL:	  fname = "pwl";	terms = aPWL;		break;
	 case eSFFM:	  fname = "sffm";	terms = aSFFM;		break;
	 case eSIN:	  fname = "sin";	terms = aSIN;		break;
	 case eTABLE:	  fname = "table";	terms = aTABLE;		break;
	 case eTANH:	  fname = "tanh";	terms = aTANH;		break;

	 case eIC:	  fname = "ic";	   	terms = aIC;		break;
	 case eII:	  fname = "ii";	   	terms = aII;		break;
	 case eIV:	  fname = "iv";	   	terms = aIV;		break;
	 case eTEMPCO:    fname = "tempco";	terms = aTEMPCO;	break;
	 default:	  fname = "\n+ ERROR";  terms = 0;		break;
      }
      where << "  " << fname;
      {if (*key == eNUMERIC){
	where << *(arg1++);
      }else if (terms == aVARIABLE){
	terms = static_cast<int>(*(arg1++)) - 1;
	where << '(';
	for (int i = 1;   i <= terms;   i++){
	  where << *(arg1++) << ' ';
	}
	where << ")";
      }else if (terms == aASSIGN){
	where << "=" << *(arg1++);
      }else if (terms > 0){
	where << '(';
	for (int i = 1;   i <= terms;   i++){
	  where << *(arg1++) << ' ';
	}
	where << ")";
      }}
    }
  }
}
/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/
