/*$Id: e_exp.h,v 13.32 1999/04/25 07:12:45 al Exp $ -*- C++ -*-
 * structures, etc for in-line expressions
 */
#include "e_elemnt.h"
#ifndef E_EXP_H
#define E_EXP_H

#define EXPRSIZE 1000

#define aVARIABLE	(-2)
#define aASSIGN		(-1)
#define eEND		0
#define eNO		0

#define eAC		1
#define eDC		2
#define eDCTRAN		3
#define eFREQUENCY	4
#define ePERIOD		5
#define eRAMP		6
#define eTIME		7
#define eTRAN		8

#define eBANDWIDTH	11
#define eCOMPLEX	12
#define eDELAY		15
#define eEXP		16
#define eEXPTERM	17
#define eGENERATOR	18
#define eNETFUNC	20
#define eNUMERIC	22
#define eOFFSET		23
#define ePOLAR		24
#define ePOLYTERM	25
#define ePULSE		26
#define ePWL		27
#define eSFFM		28
#define eSIN		29
#define eTABLE		30
#define eTANH		31

#define eIC		41
#define eII	 	42
#define eIV		43
#define eTEMPCO		44

#define aAC		0
#define aDC		0
#define aDCTRAN		0
#define aFREQUENCY	1
#define aPERIOD		1
#define aRAMP		1
#define aTIME		1
#define aTRAN		0

#define aBANDWIDTH	2
#define aCOMPLEX	2
#define aDELAY		2
#define aEXP		6
#define aEXPTERM	2
#define aGENERATOR	1
#define aNETFUNC	aVARIABLE
#define aNUMERIC	1
#define aOFFSET		2
#define aPOLAR		2
#define aPOLYTERM	2
#define aPULSE		7
#define aPWL		aVARIABLE
#define aSFFM		5
#define aSIN		5
#define aTABLE		aVARIABLE
#define aTANH		2
#define aIC		aASSIGN
#define aII	 	aASSIGN
#define aIV		aASSIGN
#define aTEMPCO		aASSIGN

class EXPRESSION_COMMON : public COMPONENT_COMMON {
public:
  explicit	EXPRESSION_COMMON(int c=0)
    :COMPONENT_COMMON(c), keys(0), args(0) {untested();}
  explicit EXPRESSION_COMMON(const int* k, int kc, const double* a, int ac);
  void		tr_eval(COMPONENT*d)const;
  void		ac_eval(COMPONENT*d)const;
  bool		has_tr_eval()const	{return true;}
  bool		has_ac_eval()const	{return true;}
  const char*	name()const		{untested();return"ureca-expression";}
private:
  explicit EXPRESSION_COMMON(const EXPRESSION_COMMON& p)
    :COMPONENT_COMMON(p), keys(p.keys), keycount(p.keycount), 
     args(p.args), argcount(p.argcount) {untested();} // ptr bug???
public:
  int* keys;
  int keycount;
  double* args;
  int argcount;
};
/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/
#endif
